/* **********************************************************
 * Copyright 1998-2003 VMware, Inc.  All rights reserved.
 * -- VMware Confidential
 * **********************************************************/

/*
 * vm_basic_asm_x86_64.h
 *
 *	Basic x86-64 asm macros
 */

#ifndef _VM_BASIC_ASM_X86_64_H_
#define _VM_BASIC_ASM_X86_64_H_

#define INCLUDE_ALLOW_MODULE
#include "includeCheck.h"


#ifdef __GNUC__
/*
 * Checked against the Intel manual and GCC --hpreg
 *
 * volatile because the tsc always changes without the compiler knowing it.
 */
static INLINE uint64 RDTSC(void)
{
   uint32 low, high;
   uint64 tim;

   __asm__ __volatile__(
      "rdtsc"
      : "=a" (low), "=d" (high)
   );

   tim = ((uint64)low) | (((uint64)high) << 32);
   return tim;
}
#elif _MSC_VER
#pragma warning( disable : 4035)
static INLINE uint64 RDTSC(void)
{
   __asm _emit 0x0f __asm _emit 0x31
}
#pragma warning (default: 4035)
#else
#error No compiler defined for RDTSC
#endif


#endif
